"use strict";

var _require = require("gatsby-page-utils"),
    createPath = _require.createPath; // Changes something like
//   `/Users/site/src/pages/foo/[id]/`
// to
//   `/foo/:id`


function translateInterpolationToMatchPath(createdPath) {
  var _createdPath$split = createdPath.split("src/pages"),
      path = _createdPath$split[1];

  return path.replace("[", ":").replace("]", "").replace(/\/$/, "");
}

exports.createClientOnlyPage = function createClientOnlyPage(absolutePath, actions) {
  console.log("client only", absolutePath); // Create page object

  var createdPath = createPath(absolutePath);
  var matchPath = translateInterpolationToMatchPath(createdPath);
  var page = {
    path: createdPath,
    matchPath: matchPath,
    component: absolutePath
  }; // Add page

  actions.createPage(page);
};