"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

// Move this to gatsby-core-utils?
var _require = require("gatsby-page-utils"),
    createPath = _require.createPath;

var _require2 = require("./get-params"),
    getParams = _require2.getParams;

var _require3 = require("gatsby/dist/utils/babel-parse-to-ast"),
    babelParseToAst = _require3.babelParseToAst;

var _require4 = require("gatsby-core-utils"),
    createContentDigest = _require4.createContentDigest;

var _require5 = require("./derive-path"),
    derivePath = _require5.derivePath;

var _require6 = require("./rewrite-imports"),
    rewriteImports = _require6.rewriteImports;

var fs = require("fs-extra");

var traverse = require("@babel/traverse").default;

var generate = require("@babel/generator").default;

var t = require("@babel/types");

var systemPath = require("path"); // Changes something like
//   `/Users/site/src/pages/foo/[id]/`
// to
//   `/foo/:id`


function translateInterpolationToMatchPath(createdPath) {
  var _createdPath$split = createdPath.split("src/pages"),
      path = _createdPath$split[1];

  return path.replace("[", ":").replace("]", "").replace(/\/$/, "");
}

function isCreatePagesFromData(path) {
  return path.node.callee.type === "MemberExpression" && path.node.callee.property.name === "createPagesFromData" && path.get("callee").get("object").referencesImport("gatsby") || path.node.callee.name === "createPagesFromData" && path.get("callee").referencesImport("gatsby");
} // TODO: Do we need the ignore argument?


exports.createPagesFromCollectionBuilder = /*#__PURE__*/function () {
  var _createPagesFromCollectionBuilder = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(absolutePath, actions, graphql) {
    var _absolutePath$split, root, route, id, collectionCoponentsFolder, tempPath, ast, queryString, _yield$graphql, data;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _absolutePath$split = absolutePath.split("src/pages"), root = _absolutePath$split[0], route = _absolutePath$split[1];
            id = createContentDigest(route);
            collectionCoponentsFolder = systemPath.join(root, ".cache/collection-components");
            tempPath = systemPath.join(collectionCoponentsFolder, id + ".js");
            ast = babelParseToAst(fs.readFileSync(absolutePath).toString(), absolutePath);
            // -- Use the ast to find the component and query, and change the code
            // -- to export default the component, instead of our fancy api
            traverse(ast, {
              // TODO: Throw an error if this is not the export default ? just to encourage default habits
              CallExpression: function CallExpression(path) {
                if (!isCreatePagesFromData(path)) return;
                if (!t.isCallExpression(path)) return; // this might not be needed...

                var _path$node$arguments = path.node.arguments,
                    componentAst = _path$node$arguments[0],
                    queryAst = _path$node$arguments[1]; // 3 options for queryAst also

                queryString = queryAst.quasi.quasis[0].value.raw; // 3 options componentAst's _could be_
                // inline component
                // referenced componenet from within the file
                // imported component from another file
                // Case 1: inline component

                if (t.isIdentifier(componentAst)) {
                  var exportDeclaration = path.find(function (n) {
                    return t.isExportDefaultDeclaration(n);
                  });
                  exportDeclaration.node.declaration = componentAst;
                }
              },
              Program: function Program(path) {
                var imports = path.get("body").filter(function (p) {
                  return p.isImportDeclaration();
                });
                imports.forEach(function (importDeclaration) {
                  return rewriteImports(absolutePath, importDeclaration);
                });
              }
            }); // -- create the dir if it doesnt exist

            if (fs.existsSync(collectionCoponentsFolder) === false) {
              fs.mkdirSync(collectionCoponentsFolder);
            } // -- write the compiled component to a cache file


            fs.writeFileSync(tempPath, generate(ast).code); // -- Get the data, and create a page for each node
            // Not sure this is enough. Seems really brittle way of getting the array out of the query

            _context.next = 10;
            return graphql(queryString);

          case 10:
            _yield$graphql = _context.sent;
            data = _yield$graphql.data;
            // tightly dependent on the query being of form:
            // `{ allSomething { nodes { id } } }`
            Object.values(data)[0].nodes.forEach(function (node) {
              var matchPath = translateInterpolationToMatchPath(createPath(absolutePath));
              var path = derivePath(absolutePath, node);
              var params = getParams(matchPath, path);
              actions.createPage({
                path: path,
                component: tempPath,
                context: {
                  __params: params,
                  __collectionData: node
                }
              });
            });

          case 13:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  function createPagesFromCollectionBuilder(_x, _x2, _x3) {
    return _createPagesFromCollectionBuilder.apply(this, arguments);
  }

  return createPagesFromCollectionBuilder;
}();